

; this will need to be increased if we end up with more than 12 modules
MAX_MODULES     equ   12

; structure of module definition
;MOD_NAME       equ 0
 MOD_TITLE      equ 4
 MOD_WNDPROC    equ 8
 MOD_CREATE     equ 12
 MOD_TRIGGER    equ 16
 MOD_SOURCE     equ 20
 ;MOD_    equ 
 
MODULE_CLASS_STYLE  equ CS_VREDRAW or CS_HREDRAW or CS_DROPSHADOW
MODWINSTYLE         equ WS_DLGFRAME
MODWINEXSTYLE       equ WS_EX_WINDOWEDGE or WS_EX_TOPMOST or WS_EX_TOOLWINDOW


include PUDcontrol.inc

.data?

module_parent dd  ?
module_class  dd  ?
module_id_ptr dd  ?
module_source dd  ?

module_list   dd MAX_MODULES dup(?)


.data

module_list_ptr dd OFFSET module_list
module_id       dd  WM_USER+333h



.code

register_module proc hModule:DWORD
  ;=================================;
  ; add a module to the module list ;
  ;=================================;
  mov eax,module_list_ptr
  m2m [eax],hModule
  add eax,4
  mov DWORD ptr[eax],0
  mov module_list_ptr,eax
  ret
register_module endp


module_init proc hModule:DWORD
  ;============================;
  ; initialize module creation ;
  ; register module class      ;
  ;============================;
  
  mov esi,hModule
  
  mov module_parent,0
  m2m module_class,[esi]

  mov eax,[esi+MOD_TRIGGER]
  add eax,4
  mov module_id_ptr,eax
  
  m2m CEXlpszClassName, [esi]
  m2m CEXlpfnWndProc,   [esi+MOD_WNDPROC]
  
  mov CEXstyle,MODULE_CLASS_STYLE
  
  push  OFFSET CEXcbSize
  call  RegisterClassExA
  ret
module_init endp


module_activate_check proc modID:DWORD, source:DWORD
  ;=========================================;
  ; check if a module needs to be activated ;
  ;=========================================;
  
  ;get first hModule
  mov esi,OFFSET module_list
  mov edi,[esi]
  
  mod_check_next:
    ; check for trigger command
    mov edi,[edi+MOD_TRIGGER]
    mov eax,[edi]

    cmp eax,modID
    jne @F
      ; module trigger command found
      
      ; declare the activation source in case
      ; the module needs to differentiate
      m2m module_source,source
      
      ; activate the module window
      push SW_SHOWNORMAL
      push [edi+4]
      call ShowWindow
      
      ret
    @@:
    
    ; get next hModule
    add esi,4
    mov edi,[esi]
    test edi,edi
  jnz mod_check_next
  ret
module_activate_check endp


new_child_id:
  mov eax,module_id
  inc module_id
  ret


module_create proc cType  :DWORD,
		   pszText:DWORD,
		   xpos   :DWORD,
		   ypos   :DWORD,
		   cwidth :DWORD,
		   cheight:DWORD,
		   style  :DWORD,
		   parent :DWORD
  ;===================================;
  ; create a module window or control ;
  ;===================================;
  ;returns the window or control's handle
  
  LOCAL exstyle
  LOCAL childID

  push ecx
  push edx


  mov exstyle,0
  
  ; are we creating the module's parent window?
  cmp module_parent,0
  jne @F
    ; substitute module window creation paramaters
    
    mov xpos,CW_USEDEFAULT
    mov ypos,CW_USEDEFAULT
    
    m2m parent , hWindow
    
    mov exstyle,MODWINEXSTYLE
    mov style  ,MODWINSTYLE
    
    m2m cType  ,module_class
    mov childID,0
    
    jmp skip_control_classing
  @@:
  
    
    ; assign class defaults for control types
    mov ecx,cType
    
    mov eax,style
    or eax,[ecx]
    mov style,eax
    
    add ecx,4
    mov eax,exstyle
    or eax,[ecx]
    mov exstyle,eax
  
    add ecx,4
    m2m cType,[ecx]

    ; is the control's parent still undefined?
    cmp parent,0
    jnz @F
      ; assign the default parent window
      m2m parent,module_parent
    @@:

    ; get a new child ID
    call new_child_id
    mov childID,eax
  
  skip_control_classing:


  ; create the window/control
  push 0
  push CEXhInstance
  push childID
  push parent
  push cheight
  push cwidth
  push ypos
  push xpos
  push style
  push pszText
  push cType
  push exstyle
  call CreateWindowEx

  ; Have we created the module's main window
  ; or a child control on that window?
  cmp module_parent,0
  jnz @F
    ; Module Window ;
    
    ; set as default parent window for
    ; created controls
    mov module_parent,eax
    
    ; put the window handle in the id list 
    ; instead of the child ID 
    mov childID,eax
  @@:
  
  ;store the control's ID in the id list
  mov edx,module_id_ptr
  m2m [edx],childID
  
  ;update the module list pointer
  add edx,4
  mov module_id_ptr,edx
  
  pop edx
  pop ecx
  
  ret
module_create endp






